#!/bin/python3.9

def test(x, y):
    if y % 4:
        return 0
    ratio = y // 4 + 1
    target_x = (ratio - 2)**2
    return target_x == x

total_n = int(input())
s = input()

x_acc = [0] # reprezentuje kolik jich bylo PRED indexem
y_acc = [0] # reprezentuje kolik jich bylo PRED indexem

x_so_far = 0
y_so_far = 0

for c in s:
    if c == 'X':
        x_so_far += 1
    else:
        y_so_far += 1
    x_acc.append(x_so_far)
    y_acc.append(y_so_far)

ret = 0

for interval_start in range(total_n - 9 + 1):
    for n in range(3, total_n):
        n2 = n * n
        interval_end = interval_start + n2
        if interval_end > total_n:
            break
        #print('interval_start =', interval_start)
        #print('interval_end   =', interval_end)
        x_in_segment = x_acc[interval_end] - x_acc[interval_start]
        y_in_segment = y_acc[interval_end] - y_acc[interval_start]
        #print('x_in_segment   =', x_in_segment)
        #print('y_in_segment   =', y_in_segment)

        ret += test(x_in_segment, y_in_segment)
        ret += test(y_in_segment, x_in_segment)

#print('x_acc =', x_acc)
#print('y_acc =', y_acc)
#print('len(*_acc) =', len(x_acc))

#print('ret =', ret)

print(ret)
