#!/bin/python3.9
# TODO - body v poslednim intervalu nejak chytre oznacit z konec

from pprint import pprint

edges = {} # i -> (target, dist)

def points_distance(p1, p2):
    ret = abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])
    return ret

def connect_two_intervals(prev_points, next_points):
    global edges
    for i in range(len(prev_points)):
        if len(prev_points) == 1:
            prev1 = prev2 = prev_points[i]
            dist_between = 0
        else:
            prev1 = prev_points[i]
            prev2 = prev_points[1 - i]
            dist_between = points_distance(prev1, prev2)

        for next_p in next_points:
            print(prev1, 'to', next_p, '(other:', prev2, ')')
            print('dist_between', dist_between)
            dist_to_next = points_distance(prev2, next_p)
            print('dist_to_next', dist_to_next)
            print()
            dist = dist_to_next + dist_between
            print('type edges', type(edges))
            edges.setdefault(prev1, []).append((next_p, dist))

volcanoes = {}

n = int(input())
for i in range(n):
    x, y = map(int, input().split())
    interval = volcanoes.setdefault(x, [y, y])
    if y < interval[0]:
        interval[0] = y
    if y > interval[1]:
        interval[1] = y

print(volcanoes)

sorted_keys = sorted(volcanoes.keys())
x = sorted_keys[0]
y = volcanoes[x]
prev_points = [(x, y[0]), (x, y[1])] if y[0] != y[1] else [(x, y[0])]

edges['start'] = [(prev_point, 0) for prev_point in prev_points]

print('prev_points =', prev_points)

for x in sorted_keys[1:]:
    y = volcanoes[x]
    curr_points = [(x, y[0]), (x, y[1])] if y[0] != y[1] else [(x, y[0])]
    connect_two_intervals(prev_points, curr_points)
    print('curr_points =', curr_points)

    prev_points = curr_points

for i in range(len(prev_points)):
    if len(prev_points) == 1:
        p1 = prev_points[i]
        edges[p1] = ('end', 0)
    else:
        p1 = prev_points[i]
        p2 = prev_points[1 - i]
        dist = points_distance(p1, p2)
        edges.setdefault(p1, []).append('end', dist)

pprint(edges)
